require 'mscorlib'
require 'System.Windows.Forms'
require 'System.Drawing'

class FormProgressDialog

  def initialize(queue, updatescreen)
    @value = 0
    @pass = 0
    @pass_max = 1
    @max = 100
    @min = 0
    # - thread message queue
    @thread_queue = queue
    @screen = updatescreen
    # - controls instance
    @form = System::Windows::Forms::Form.new()
    @progressBar1 = System::Windows::Forms::ProgressBar.new()
    @label2 = System::Windows::Forms::Label.new()
    @label1 = System::Windows::Forms::Label.new()
    @button_progress = System::Windows::Forms::Button.new()
    @timer = System::Windows::Forms::Timer.new()
    create
  end

  attr_accessor :value
  attr_accessor :max
  attr_accessor :pass
  attr_accessor :pass_max

  def create
    @form.SuspendLayout()
    #
    @progressBar1.Location = System::Drawing::Point.new(12, 50)
    @progressBar1.Name = 'progressBar1'
    @progressBar1.Size = System::Drawing::Size.new(370, 23)
    @progressBar1.Step = 1
    #
    @label1.AutoSize = true
    @label1.Location = System::Drawing::Point.new(12, 20)
    @label1.Name = 'label1'
    @label1.Size = System::Drawing::Size.new(29, 12)
    @label1.Text = 'pass'
    #
    @label2.AutoSize = true
    @label2.Location = System::Drawing::Point.new(57, 20)
    @label2.Name = 'label2'
    @label2.Size = System::Drawing::Size.new(23, 12)
    @label2.Text = '0/0'
    #
    @button_progress.DialogResult = System::Windows::Forms::DialogResult.Cancel
    @button_progress.Location = System::Drawing::Point.new(311, 88)
    @button_progress.Name = 'button_progress'
    @button_progress.Size = System::Drawing::Size.new(71, 21)
    @button_progress.TabIndex = 0
    @button_progress.Text = 'Cancel'
    @button_progress.UseVisualStyleBackColor = true
    #
    @timer.Interval = 100
    @timer.Enabled = false
    @timer.Tick.add( proc { timer_tick } )
    # ---
    @form.ClientSize = System::Drawing::Size.new(394, 121)
    @form.FormBorderStyle = System::Windows::Forms::FormBorderStyle.FixedDialog
    @form.StartPosition = System::Windows::Forms::FormStartPosition.CenterParent
    @form.ControlBox = false
    @form.Controls.Add( @button_progress )
    @form.Controls.Add( @label2 )
    @form.Controls.Add( @label1 )
    @form.Controls.Add( @progressBar1 )
    @form.MaximizeBox = false
    @form.MinimizeBox = false
    @form.Name = 'progress_dialog'
    @form.ShowInTaskbar = false
    @form.Text = 'Progress'
    @form.ResumeLayout(false)
    @form.PerformLayout()
  end


  def show_dialog
    @timer.Enabled = true
    @form.ShowDialog()
  end

  def refresh
    @form.Paint
  end

  def done
    @timer.Enabled = false
    @form.Close
  end

  def timer_tick
    if @thread_queue.empty? == false then
      m = @thread_queue.pop
      if m.done == true then
        done
      else
        @progressBar1.Maximum = m.jobnum
        @progressBar1.Value = m.progress
        @label2.Text = sprintf("%d/%d", m.pass, m.passnum)
        # - OpenGL update
        if (m.item_tri != nil) || (m.item_line != nil)
          @screen.clear_pattern_object
          if m.item_tri != nil then
            m.item_tri.each do |tri|
              @screen.add_object(tri)
            end
          end
          if m.item_line != nil then
            m.item_line.each do |line|
              @screen.add_line(line)
            end
          end
          m.item_overline.each do |pat|
            pat.each do |line|
              @screen.add_line(line)
            end
          end
          @screen.view_reset
        end
      end
    end
  end

end
