
class PreferenceHolder

  def initialize
    @pref = {
      "resolution"   => "24",
      "pass"         => "2",
      "cuttersize"   => "0.24",
      "patternfeed"  => "30.0",
      "patterndepth" => "0.1",
      "outlinefeed"  => "80.0",
      "outlinelayer" => "0.4",
      "boardthin"    => "1.65",
      "drilldepth"   => "1.70",
      "drilldwell"   => "0",
      "drillinputfix" => "4"
    }
  end

  def get(key)
    @pref[key]
  end

  def set(key, value)
    if @pref.include?(key) == true then
      @pref[key] = value.to_s
    end
  end

  def load
    result = true
    begin
      open("pref.ini", "r") do |fp|
        fp.each do |line|
          chank = line.split(' ')
          next if @pref.include?(chank[0]) == false
          @pref[chank[0]] = chank[1]
        end
      end
    rescue
      result = false
    end
    result
  end

  def save
    open("pref.ini", "w") do |fp|
      @pref.each do |item, value|
        fp << sprintf("%s %s\n", item, value)
      end
    end
  end
end
